<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Product</title>
    <link rel="stylesheet" type="text/css" href="custom.css" />
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.3.1/css/bootstrap.min.css"
        integrity="sha256-YLGeXaapI0/5IgZopewRJcFXomhRMlYYjugPLSyNjTY=" crossorigin="anonymous" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.4.1/jquery.min.js"
        integrity="sha256-CSXorXvZcTkaix6Yvo6HppcZGetbYMGWSFlBw8HfCJo=" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.3.1/js/bootstrap.min.js"
        integrity="sha256-CjSoeELFOcH0/uxWu6mC/Vlrc1AARqbm/jiiImDGV3s=" crossorigin="anonymous"></script>

</head>

<body>
    <nav class="navbar navbar-expand-md navbar-dark bg-dark fixed-top">
        <a class="navbar-brand" href="#">Product</a>
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNavAltMarkup"
            aria-controls="navbarNavAltMarkup" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse" id="navbarNavAltMarkup">
            <div class="navbar-nav">

                <a class="nav-item nav-link" href="javascript:;" id="logout">Logout</a>
            </div>
        </div>
    </nav>
    <main role="main" class="container starter-template">
        <h2>Add New Product</h2>
        <form id='form'>
            <div class="form-group">
                <label for="name">Name</label>
                <input type="text" class="form-control" name="name" id="name" required />
            </div>
            <div class="form-group">
                <label for="description">Description</label>
                <input type="text" class="form-control" name="description" id="description" required />
            </div>
            <div class="form-group">
                <label for="description">Price</label>
                <input type="text" class="form-control" name="price" id="price" required />
            </div>
            <div class="form-group">
                <label for="category_id">Category</label>
                <select class="form-control" name="category_id" id="category_id" required>
                    <option value=""></option>
                    <option value="1">Fashion</option>
                    <option value="2">Electronics</option>
                    <option value="3">Motors</option>
                </select>
            </div>
            <button type='submit' class='btn btn-primary'>Save</button>
            <button type='reset' class='btn btn-link'>Reset</button>
        </form>
        <hr />
        <h2>Products</h2>
        <table id="table" class="table table-striped table-bordered">
            <thead class="thead-dark">
                <tr>
                    <th scope="col">ID</th>
                    <th scope="col">Name</th>
                    <th scope="col">Description</th>
                    <th scope="col">Price</th>
                    <th scope="col">Category</th>
                </tr>
            </thead>
            <tbody id="tbody"></tbody>
        </table>
    </main>
    <script>
        $(document).ready(function () {


            const token = localStorage.getItem('token');
            if (!token) {
                window.location.href = "/";
            }
            $(document).on('click', '#logout', function (e) {
                e.preventDefault();
                localStorage.removeItem('token');
                window.location.href = "/";
            });

            $(document).on('submit', '#form', function (e) {
                e.preventDefault();
                const form = $(this);
                // get form data
                const form_obj = form.serializeObject();
                const form_data=JSON.stringify(form_obj);

               
                $.ajax({
                    url: 'http://api.wnp.test:8085/v2/products',
                    type: "POST",
                    headers: {
                        'Authorization': `Bearer ${token}`,
                    },
                    contentType: 'application/json',
                    data: form_data,
                    crossDomain: true,
                    timeout: 60000,
                    beforeSend: function () {
                       
                    },
                    error: function (xhr, ajaxOptions, thrownError) {

                    },
                    success: function (data) {
                        alert('Add Data Successfully');
                        form.trigger("reset");
                        product.search();
                    }
                });
            });

            // function to make form values to json format
            $.fn.serializeObject = function () {

                var o = {};
                var a = this.serializeArray();
                $.each(a, function () {
                    if (o[this.name] !== undefined) {
                        if (!o[this.name].push) {
                            o[this.name] = [o[this.name]];
                        }
                        o[this.name].push(this.value || '');
                    } else {
                        o[this.name] = this.value || '';
                    }
                });
                return o;
            };

            product = {
                search: function () {

                    $.ajax({
                        url: 'http://api.wnp.test:8085/v2/products',
                        type: "GET",
                        headers: {
                            'Authorization': `Bearer ${token}`,
                        },
                        crossDomain: true,
                        timeout: 60000,
                        beforeSend: function () {
                            $("#tbody").empty();
                        },
                        error: function (xhr, ajaxOptions, thrownError) {},
                        success: function (data) {
                            const records = data.result.records;

                            let tbody = $('#tbody');
                            $.each(records, function (key, object) {

                                let html = `
                                    <tr>
                                        <td>${object.id}</td>
                                        <td>${object.name}</td>
                                        <td>${object.description}</td>
                                        <td>${object.price}</td>
                                        <td>${object.category_name}</td>
                                    </tr>
                                `;

                                tbody.append(html);
                            });

                        }
                    });
                }
            }

            product.search();
        });
    </script>
</body>

</html>